精华内容
下载资源
问答
  • 不知道你是不是忘记写dfs的终止条件了? 问题在于此时的递归没有终点,改成这样就好了。

    在这里插入图片描述

    不知道你是不是忘记写dfs的终止条件了?

    在这里插入图片描述

    问题在于此时的递归没有终点,改成这样就好了。

    在这里插入图片描述

    展开全文
  • 未处理异常的处理

    千次阅读 2018-06-19 11:49:41
    AppDomain.Unhandled...但是当某个异常我们未添加try/catch进行捕捉时,它便会造成程序出错,此即为未处理异常未处理异常一般会造成程序终止。 Occurs when an exception is not caught. 当某个异常未被...

    在启动项目的Main函数的开头加上(注意,一定要加在Main函数的最前面):

    //捕获GUI异常,无GUI则不需要加
    Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);//
    
    //捕获线程异常,捕获不了GUI异常
    AppDomain.CurrentDomain.UnhandledException += CurrentDomain_UnhandledException;//msheng,处理线程异常
    

    译文:
    AppDomain.UnhandledException Event
    译者:我们知道,对于一些可预见性的错误常常需要在代码外围添加try/cahch块进行错误的捕捉与恢复处理。但是当某个异常我们未添加try/catch进行捕捉时,它便会造成程序出错,此即为未处理异常,未处理异常一般会造成程序终止。
    Occurs when an exception is not caught.
    当某个异常未被捕捉时此事件将被触发
    Remarks
    This event provides notification of uncaught exceptions. It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. If sufficient information about the state of the application is available, other actions may be undertaken — such as saving program data for later recovery. Caution is advised, because program data can become corrupted when exceptions are not handled.
    注意:
    此事件提供未捕捉异常的通知。此通知发生在系统报告异常并终止程序之前,因此可以在此通知发生时记录异常日志以供后期调试。另外,如果程序数据未被严重破坏,可采取一些措施保存数据以供程序重启后恢复到异常出现之前的状态。此操作需谨慎。因为一般来讲,程序数据都是被破坏的。
    Note
    In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.
    备注:
    在.NET Framework 1.0 and 1.1中,系统会先报告异常并终止应用程序,然后才会触发未捕捉异常的通知。
    This event can be handled in any application domain. However, the event is not necessarily raised in the application domain where the exception occurred. An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.
    此事件能在任何App Domain中被处理。但是,我们不必在每个App Domain中都添加该事件的处理器。一个异常仅当整个线程栈都未找到可应用的异常处理器时才被定义为未处理异常,所以此事件最可能被触发的地方是App Domain中线程栈的起点。也就是说,只要在最可能触发该事件的地方添加事件处理器即可。
    Note
    In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.
    备注:
    在.NET Framework 1.0 and 1.1中,此事件仅适用于默认的App Domain(即应用程序启动时,系统创建的App Domain,即启动项)。如果应用程序创建了额外的App Domain,在该app domian中为此事件指定委托并不会生效。
    If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.
    如果默认App Domain中添加了UnhandledException处理器,那么任何线程中抛出的未处理异常都会执行该处理器,不论该线程起始于哪个App Domain。如果非默认App Domain中也添加了未处理异常的处理器,那么默认App Domain和非默认App Domain中的未处理异常处理器均会被触发。
    (字面翻译:如果UnhandledException事件在默认的App Domain中被处理了,那么在任何线程中的任何未处理异常都会触发该UnhandledException,不管这个线程是起始于哪个App Domain的。如果这个线程起始于一个拥有UnhandledException的App Domain,这个事件会在该App Domain中触发。如果该App Domain不是默认的App Domain,并且默认的App Domain中有UnhandledException的处理器,该事件会在两个App Domain中均被触发。)
    For example, suppose a thread starts in application domain “AD1”, calls a method in application domain “AD2”, and from there calls a method in application domain “AD3”, where it throws an exception. The first application domain in which the UnhandledException event can be raised is “AD1”. If that application domain is not the default application domain, the event can also be raised in the default application domain.
    例如,假设一个线程起始于AD1 App Domain,并且调用了AD2 App Domain中的一个方法,且该方法又调用了AD3 App Domain中的一个方法,刚好在AD3 App Domain的方法中抛出了一个异常。这个最有可能触发UnhandledException事件的App Domain是AD1。如果AD1不是默认的App Domain,该事件也能触发于默认的App Domain。
    Note
    The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.
    备注:
    当UnhandledException事件处理器执行的时候公共语言运行时(CLR)会暂停线程终止操作。
    If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.
    如果事件处理器应用了ReliabilityContrac特性,这个事件处理器被当做约束执行区域对待(具体请了解CER,约束执行区域)。
    Starting with the .NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.
    从.NET Framework 4(包括.NET Framework 4)开始,当损坏进程状态的异常如栈溢出,访问无效等发生时,该事件不会被触发,除非此事件处理器应用了security-critical和HandleProcessCorruptedStateExceptionsAttribute特性
    In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. Thus, it is possible for the UnhandledException event to be raised without the application terminating. Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.
    在 .NET Framework 1.0 and 1.1中,当未处理异常发生于子线程(非主线程)并被运行时捕捉(添加了未处理程序处理器)时,不会造成应用程序终止。但从.NET Framework2.0开始(包括.NET Framework2.0),这种不终止程序的操作被移除了,因为会造成很多负面影响,如性能下降,数据损坏,死锁,而所有这一切都是难以调试的。要想获取更多这方面的信息,包括运行时不会被终止的案例列表,请参阅Exceptions in Managed Threads.
    To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.
    要想为此事件注册一个事件处理器,我们必须获得必须的权限,否则会抛出SecurityException异常
    For more information about handling events, see Handling and Raising Events.
    想要获取更多关于事件处理的信息,请参阅Handling and Raising Events.
    Other Events for Unhandled Exceptions
    未处理异常的其它事件
    For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.
    对于不同的应用程序模型,未处理异常所触发的事件可能不一样
    In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. In that case, the UnhandledException event is not raised. This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. This applies only to the main application thread. The UnhandledException event is raised for unhandled exceptions thrown in other threads.
    在WinForm中,主线程(UI线程)中的未处理异常将触发Application.ThreadException事件。如果此事件被处理,默认的操作下进程不会被终止,而这会使程序处于不确定的状态(数据可能损坏,持续运行下去的逻辑不一定正确等)。主线程不会触发UnhandledException事件,但是此默认行为能够通过修改应用程序的配置文件或者使用Application.SetUnhandledExceptionMode方法进行修改。
    Application.SetUnhandledExceptionMode使得UnhandledExceptionMode.ThrowException触发于ThreadException处理器被调用前。注意:在子线程中UnhandledException事件仍会被触发。
    Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. See the WindowsFormsApplicationBase.UnhandledException event. This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). In that case, the AppDomain.UnhandledException event is not raised.
    从VS2005开始,VB应用程序框架为主线程提供了另外的未处理异常事件。请参阅WindowsFormsApplicationBase.UnhandledException事件。此事件有一个事件参数对象,名字和AppDomain.UnhandledException中的一样,但属性不同。特别地,这个事件参数对象有一个ExitApplication属性,它允许应用程序继续运行,忽略未处理异常(这会使程序处于未知状态)。在主线程中,AppDomain.UnhandledException不会被触发。
    Examples
    示例
    The following example demonstrates the UnhandledException event. It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. It then throws two exceptions. The first is handled by a try/catch block. The second is unhandled and invokes the MyHandle routine before the application terminates.
    以下示例演示了UnhandledException事件。它定义了一个事件处理器MyHandler,只要默认App Domain中有未处理异常抛出它就会被触发。然后,它会抛出两个异常。第一个会被try/catch处理,第二个是未处理的,它会在程序终止之前触发MyHandle路由调用MyHandler处理器

    using System;
    using System.Security.Permissions;
    
    public class Example 
    {
       [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
       public static void Main()
       {
         AppDomain.CurrentDomain.UnhandledException += CurrentDomain_UnhandledException;
                Application.ThreadException += Application_ThreadException;
    
          try {
             throw new Exception("1");
          } catch (Exception e) {
             Console.WriteLine("Catch clause caught : {0} \n", e.Message);
          }
    
          throw new Exception("2");
       }
    
       static void ProcessUnhandledException(string exceptionMessage)
            {
                Utilities.sendLog(string.Format("程序因为未处理异常于{0}重启,具体错误信息如下:{1}"
               , DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), exceptionMessage));
                System.Diagnostics.Process.Start(Application.ExecutablePath);
                Environment.Exit(1);
            }
            private static void Application_ThreadException(object sender, ThreadExceptionEventArgs e)
            {
                ProcessUnhandledException(e.Exception.ToString());
            }
    
            private static void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
            {
                ProcessUnhandledException(((Exception)e.ExceptionObject).ToString());
            }
    }
    // The example displays the following output:
    //       Catch clause caught : 1
    //       
    //       MyHandler caught : 2
    //       Runtime terminating: True
    //       
    //       Unhandled Exception: System.Exception: 2
    //          at Example.Main() 
    

    Security
    安全
    SecurityCriticalAttribute
    SecurityCriticalAttribute特性
    requires full trust for the immediate caller. This member cannot be used by partially trusted or transparent code.
    需要获得对即时调用者的完全信任。此成员不能被使用partially trusted或者transparent code.

    总结:

    1. 未处理异常的作用是用于日志记录与数据恢复。
    2. 非UI线程中的未处理异常会触发AppDomain.UnhandledException事件。
    3. 在默认App Domain中添加的未处理异常处理器肯定会被触发。
      如果在其他App Domain中也添加了未处理异常处理器,则两个处理器都会被触发。
    4. 不同程序模型未处理异常发生时触发的事件不同。
    5. .NET Framework2.0以后(包括.NET Framework2.0)的程序中的未处理异常触发于进程终止之前。而.NET Framework 1.0 and 1.1中的未处理异常触发于程序终止之后。
    6. 在添加了未处理异常处理器的前提下,.NET Framework 1.0 and 1.1中,子线程触发未处理异常时程序不会被终止,自.NET Framework2.0后修复了这个问题

    The proper method would be Application.Exit(). According to the Documentation, it terminates all message loops and closes all windows thus giving your forms the possibility to execute their cleanup code (in Form.OnClose etc).

    Environment.Exit would just kill the process. If some form has e.g. unsaved changes it would not have any chances to ask the user if he wants to save them. Also resources (database connections etc.) could not be released properly, files might not be flushed etc.

    Form.Close just does what it says: it closes a form. If you have other forms opened (perhaps not now but in some future version of your application), the application will not terminate.

    Keep in mind that if you use multithreading, Application.Exit() will not terminate your threads (and thus the application will keep working in the background, even if the GUI is terminated). Therefore you must take measures to kill your threads, either in the main function (i.e. Program.Main()) or when in the OnClose event of your main form.

    展开全文
  • ![图片说明](https://img-ask.csdn.net/upload/201708/19/1503121020_685199.jpg) 反复出现这个问题,除了重装,好的办法么,求教
  • ub1.exe 中的 0x777015de 处有未经处理异常: 0xC0000005: 读取位置 0xfeeefef6 时发生访问冲突断点是下在WinMian最后那里,也就是说不是我的错。真心不知道如此叼的错误是怎么样炼成的。解决方案call sta
    • ub1.exe 中的 0x777015de 处有未经处理的错误: 0xC0000005: 读取位置 0xfeeefef6 时发生访问冲突

      ub1.exe 中的 0x777015de 处有 未经 处理异常: 0xC0000005: 读取 位置 0xfeeefef6 时 发生 访问冲突断点是下在WinMian最后那里,也就是说不是我的错。真心不知道如此叼的错误是怎么样炼成的。解决方案call stack就是调用堆栈,调试时,点菜单“调试”-》“窗口”-》“调用
    • 未经处理的错误: 0xC0000005: 读取位置 0xcccccccc 时发生访问冲突 咋回事啊大侠帮忙

      未经 处理异常: 0xC0000005: <…………………………………………………………………………

      具体请点击:http://www.verydemo.com/demo_c92_i27255.html

    展开全文
  • 主要介绍了Java线程组与未处理异常,结合实例形式分析了java线程组处理异常的相关技巧与操作注意事项,需要的朋友可以参考下
  • 异常处理是每个应用程序都会用到的,纵然在程序编写期间我们都会最大限度的考虑可能发生的异常并进行相应的处理,但是往往并不能完全考虑周全,百密一疏,出现未处理异常而导致程序出错,数据丢失,如用户输入错误...
  • 主要介绍了C++中指定的异常未经处理异常,介绍了有关noexcept和terminate的作用,并结合了C++11标准的新特性,需要的朋友可以参考下
  • 有未经处理异常

    2014-12-30 17:56:19
    本人产生的这个问题,是由于使用的变量没有经过初始化
    本人产生的这个问题,是由于使用的变量没有经过初始化
    展开全文
  • 主要给大家介绍了关于.net中捕捉全局未处理异常的三种方式,分别是Page_Error处理页面级未处理异常、通过HttpModule来捕获未处理的异常以及通过Global中捕获未处理的异常,需要的朋友可以参考下
  • 有未经处理异常: 0xC0000374

    千次阅读 2020-04-24 15:02:31
    有未经处理异常: 0xC0000374: 堆已损坏 关于处有未经处理异常: 0xC0000374: 堆已损坏的问题, 调试不出错, 直接执行很大几率出错的问题, 最后的跟踪都是在delete的时候报错!. 我的解决方法: 在申请内存处, 申请...
  • 未经处理异常 char
  • 我的问题是代码中文件的路径直接复制过来是这样子的:E:\college to graduate\image\022.jpg 改为:E:\\college to graduate\\image\\022.jpg后问题得到解决。
  • WinForm捕获未处理异常
  • 表示使用了创建(分配...因为成员变量中指针,只是进行了简单赋值,指针并深拷贝,所以在另一个函数调用时出错。 GenTL::PORT_HANDLE devicePort; CC(tl, tl->DevGetPort(deviceHandle, &devicePort)...
  • 未处理异常 0xC0000374: 堆已损坏 malloc的一种解决方案问题分析解决办法解决办法1解决办法2 问题 在使用VS的过程中, 当我们在某个函数中写malloc函数(C)或者new(C++)时,经常会出现 (ntdll.dll)(XXX.exe中...
  • “System.AccessViolationException”类型的未经处理的异常在System.Data.dll中发生 其他信息:尝试读取或写入受保护的内存。这通常指示其他内存已损坏。 未处理System.AccessViolationExceptionHResult=-...
  • HVSnapContinuous.exe 中的 0x7574812f 处有未经处理异常: Microsoft C++ 异常: 内存位置 0x0033f3e4 处的 cv::Exception。 mfc画完矩形后onlbuttonup之后单步调试在 int CWinThread::Run() { ASSERT_VALID(this)...
  • 已经确定错误出现在updateMenus()和connect()两句中。...0x6463477C (Qt5Widgetsd.dll) (myMdi.exe 中)处有未经处理异常: 0xC0000005: 读取位置 0x00000D50 时发生访问冲突。 我不太明白这里是什么意思? 求指教
  • 主要介绍了C# WinForm捕获未处理异常,包括了常见的未捕获的异常、UI线程异常、非UI线程异常等,非常实用,需要的朋友可以参考下
  • 错误:0x000F6C08 处有未经处理异常(在 hannuota bahuanghou.exe 中): 0xC0000005: 写入位置 0x000FDA8C 时发生访问冲突。 就这一小段代码出错了 我知道出错的地方 但不知道原因 望各位指点指点
  • 0x012B2A4D 处有未经处理异常(在 Project21.exe 中): 0xC0000005: 读取位置 0x00000000 时发生访问冲突。
  • 使用vs运行程序时我们时候会看到这样的一个错误:“XXX处有未经处理异常: 0xC0000374: 堆已损坏”。导致该错误产生的原因一般是是访问了分配的地址,内存越界造成的,越界写了不该写的内存区域。 示例:...
  • 关于处有未经处理异常: 0xC0000374: 堆已损坏的问题, 调试不出错, 直接执行很大几率出错的问题, 最后的跟踪都是在delete的时候报错!. 我的解决方法: 在申请内存处, 申请内存大小再加+1, 问题消失. m_...
  • Windows进程未处理异常和C++异常

    千次阅读 2017-07-27 15:43:36
    当一个异常过滤器返回EXCEPTION_CONTINUE_SEARCH标识符时是告诉系统继续上溯调用树,寻找另外的异常过滤器,但当每个过滤器都返回EXCEPTION_CONTINUE_SEARCH标识符,出现了所谓“未处理异常”。 每个线程开始执行,...
  • 关于vs未处理异常: 0xC00000FD: Stack overflow 出现此异常的原因是因为:栈溢出,也就是在栈上申请的空间太大了,一般都是在用数组时,申请的空间太大。 解决方法:1是: 2,第二种方法是:动态申请内存...
  • 未经处理异常

    千次阅读 热门讨论 2015-08-23 22:17:43
    【错误信息】  WebFormsUnobtrusiveValidationMode 需要“jquery”ScriptResourceMapping。... 执行当前 Web 请求期间,出现未经处理异常。请检查堆栈跟踪信息,以了解有关该错误以及代码中导致错误的出处
  • android工程全局异常处理-将未处理异常日志保存在文件中,可后续开发提交至服务器
  • nodejs 捕获未处理异常

    千次阅读 2015-09-14 12:18:41
    nodejs 捕获异步未处理异常处理比较麻烦 简单的方法是监听全局的process 的uncaughtException 进行处理 process.on('uncaughtException', function (err) { console.error('An uncaught error occurred!'...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 493,158
精华内容 197,263
关键字:

vs有未经处理的异常